/*
 * Programa: processo.cpp
 * Descrio: Simula a criao de um fork de um processo
 *
 *  IFPE, Curso de Anlise e Desenvolvimento de Sistemas
 *  Programao para Tempo Real
 *
 *  Criado em : 31/05/2011
 *      Autor : Anderson Moreira
 *      E-mail: anderson.moreira@recife.ifpe.edu.br
 *
 */

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

int main()
{
	// declarao de variveis
	pid_t pid;          // definindo um identificador de processo - inteiro longo
	char *mensagem;     // string que contm a mensagem
	int n;              // contador

	printf("Comecando o programa processo ... \n");
	pid = fork();   // dividindo o processo em dois
	switch(pid)
    {
    	case -1:       // erro na abertura do processo filho
    		exit(1);
    	case 0:        // retorno de fork para processo filho
    		mensagem = "                   Processo filho...";
    		n = 5;
    		break;
    	default:
    		mensagem = "Processo pai ...";
    		n = 3;
    		break;
    }

	for(;n>0;n--)
	{
		printf("Valor de pid %d   ",pid);
		puts(mensagem);
		usleep(1);
	}
	printf("Terminando o programa fork1 ... \n");
	exit (0);
}//fim do main
