/*
 ============================================================================
 Name        : processo.c
 Author      : Anderson Moreira
 E-mail		 : anderson.moreira@recife.ifpe.edu.br
 Version     : 13/06/2011
 Copyright   : 
 Description : Programa que cria um processo pai e dois filhos pelo fork()
 ============================================================================
 */

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

int main ()
{
	// declarao de variveis
	pid_t pid;          // definindo um identificador de processo - inteiro longo
	char *mensagem;     // string que contm a mensagem
	int n;              // contador

	printf("Comecando o programa PROCESS_3... \n");
	pid = fork();   	// dividindo o processo em dois
	switch(pid)
    {
    	case -1:       	// erro na abertura do processo filho
    		exit(1);
    	case 0:        	// retorno de fork para processo filho
    		system("ps ");
    		mensagem = "                   Processo filho...";
    		n = 5;
    		break;
    	default:
    		mensagem = "Processo pai ...";
    		n = 3;
    	break;
    }

	for(;n>0;n--) {
		printf("Valor de pid %d   ",pid);
		puts(mensagem);
		if ((5-n) == 4) {
			system("ps ");
		}
		sleep(1);
	}
	printf("Terminando o programa PROCESS_3 ... \n");
	exit (0);
}
