/*
 ============================================================================
 Name        : processo.c
 Author      : Anderson Moreira
 E-mail		 : anderson.moreira@recife.ifpe.edu.br
 Version     : 13/06/2011
 Copyright   : 
 Description : Simula a espera de um processo pela funo wait()
 ============================================================================
 */

#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

int main()
{
	// declarao de variveis
	pid_t pid;          // definindo um identificador de processo - inteiro longo
	char *mensagem;     // string que contm a mensagem
	int n;              // contador
	int exit_code;      // cdigo para sada

	printf("Comecando o programa PROCESS_6 ... \n");
	pid = fork();   // dividindo o processo em dois
	switch(pid)
    {
    	case -1:       // erro na abertura do processo filho
    		exit(1);
    	case 0:        // retorno de fork para processo filho
    		//system("ps ");
    		printf("\n\n");
    		mensagem = "                   Processo filho...";
    		n = 5;
    		exit_code = 37; // cdigo de sada do filho, tente colocar outros valores 39, 29 123 233
    		break;
    	default:
    		mensagem = "Processo pai ...";
    		n = 3;
    		exit_code = 0;
    		break;
    }

	for(;n>0;n--) {
		printf("Valor de pid %d   ",pid);
		puts(mensagem);
		sleep(1);
	}

	if(pid)
	{
		int stat_val;
		pid_t pid_filho;

		pid_filho = wait(&stat_val);

		printf("O Filho foi finalizado: PID = %d \n", pid_filho);

		// WIFEXITED(stat_val) - no-zero se o filho terminou normalmente
		// WEXITSTATUS(stat_val) - se WIFEXITED  no-zero, retorna o cdigo de sada do filho
		if(WIFEXITED(stat_val))
			printf("O Filho terminou com codigo  %d\n", WEXITSTATUS(stat_val));
		else
			printf("O Filho terminou de forma anormal \n");
    }
	printf("Terminando o programa PROCESS_6 ... \n");
	exit(exit_code);
}
